﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing; //Bitmap /May later need for Rectangle as well.
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

//using System.Drawing; //Bitmap/Rectangle
using System.Drawing.Imaging; //PixelFormat
using System.Runtime.InteropServices; //Marshal

namespace gsmagic {
    public partial class Form1 : Form {
        public Form1() {
            InitializeComponent();
        }
        //Form load > Open/Save ROM
        private void Form1_Load(object sender, EventArgs e) {
            //MessageBox.Show((unchecked((ulong)-1)<<0x40).ToString("X16"));
            //byte[] ba = {7,7,7,7};
            //System.Media.SoundPlayer test = new System.Media.SoundPlayer(new MemoryStream(ba));
            //test.
            if (System.IO.File.Exists(Properties.Settings.Default.LastRom)) { OpenROM(Properties.Settings.Default.LastRom); } else { OpenROMdialogue(); }
            //DateTime a = DateTime.Now;//.Ticks;
            //byte[] t = decompress(rom, 0xA8B1B8, 0); //Format 2
            //byte[] t = decompress(rom, 0x888FE4 + 0x80, 0); //Format 2
            //byte[] t = decompress16(rom, 0x4F157, 0); //Format 2
            //byte[] t = decompText(rom, 0x111); // decompBtlBG(rom, 0x7765D8 + 0x100);
            //byte[] t = decompText(rom);
            //comptext(t, rom);;
            //Editors a = new Editors();
            //a.Show();
            //a.tabControl = 0;
            //a.rom = rom;
            //DateTime c = DateTime.Now;//.Ticks;
            //Console.WriteLine((c - a).ToString());
            //System.IO.File.WriteAllBytes("C:/Users/Tea/Desktop/gsdtest.dmp", t);
            //DateTime a = DateTime.Now;//.Ticks;
            //loadEntireMap();
            //DateTime c = DateTime.Now;//.Ticks;
            //Console.WriteLine((c - a).ToString());
            //System.IO.File.WriteAllBytes("C:/Users/Tea/Desktop/gsdtest2.dmp", decompText(rom));
        }
        private void OpenROMdialogue() {
            OpenFileDialog ofd = new OpenFileDialog();
            ofd.Title = "Open a GBA/NDS File";
            ofd.Filter = "GBA/NDS/3DS file(*.gba;*.nds;*.3ds)|*.gba;*.nds;*.3ds";
            if (ofd.ShowDialog() == DialogResult.OK) { OpenROM(ofd.FileName); }
        }
        //public static Bits rom = new Bits();
        //public static Bits ram = new Bits();
        //Public OpenFileDialog1 = ""
        public byte[] rom;
        string romfn;
        int version = -1;
        int filetable = -1;
        char language;
        private void OpenROM(string filename) { //TODO: If new filename is error/incompatible, revert to old file.
            //mainMem.setPath(filename)
            //string vstr = ""; //Dim vstr As String = ""
            if (filename.EndsWith(".gba", true, null)) { //Load entire ROM to buffer; GBA ROMs are maxed at 32 MB.
                rom = Bits.openFile(filename);
                if (rom == null) { this.Text = "Error reading ROM file."; return; }
                //rom.seek(0xA0);
                //vstr = Bits.getString(rom, 0xA0, 16);
                //ram.buffer = new byte[0x40000];
                switch (Bits.getString(rom, 0xA0, 15)) {
                    case "Golden_Sun_AAGS":
                    case "OugonTaiyo_AAGS":
                        version = 0; filetable = 0x08320000; break;
                    case "GOLDEN_SUN_BAGF":
                    case "OUGONTAIYO_BAGF":
                        version = 1; filetable = 0x08680000; break;
                    case "MARIOTENNISABTM":
                        version = 11; filetable = 0x08C28000; break;
                    case "MARIOGOLFGBABMG":
                        version = 10; filetable = 0x08800000; break;
                    //default:
                    //    MessageBox.Show("Not a compatible ROM.");
                    //    break;
                }
                language = (char)rom[0xAF];
                if (language == 'E' && version == 1) { //Chinese check
                    if (Bits.getUInt32(rom, 0x08090000 & 0x01FFFFFF) == 0xEA00002E && //unchecked((int)0xEA00002E) && //Make UInt?
                        Bits.getUInt32(rom, 0x08090004 & 0x01FFFFFF) == 0x51AEFF24 &&
                        Bits.getUInt32(rom, 0x08090008 & 0x01FFFFFF) == 0x21A29A69 &&
                        Bits.getUInt32(rom, 0x0809000C & 0x01FFFFFF) == 0x0A82843D) {
                        language = 'C';
                    }
                } else if (version == 0) {
                    switch (language) {
                        case 'E':
                        case 'I': filetable = 0x08320000; break;
                        case 'J': filetable = 0x08317000; break;
                        case 'D': filetable = 0x0831FE00; break;
                        case 'F':
                        case 'S': filetable = 0x08321800; break;
                    }
                }
                //File table verification.
                if (((Bits.getUInt32(rom, filetable & 0x01FFFFFF) >> 24) != 8) ||
                    (Bits.getUInt32(rom, (filetable + 4) & 0x01FFFFFF) != filetable)) {
                    //Incompatible
                }
                //TODO: Reorganize repointed data from Atrius's editor back into where they should belong.
                //Text data, filetable/map code data, Innate psys.
                //count_freespace()
                //init_globals
                //with (obj_MasterEditor) { sel=6*(global.version>=10); event_user(0); }

                //} else if (filename.EndsWith(".nds", true, null)) { //Dark Dawn?
            }
            romfn = filename;
            Properties.Settings.Default.LastRom = filename;
            Properties.Settings.Default.Save();
            loadEntireMap();
        }
        //Toolbar > File menu
        private void openToolStripMenuItem_Click(object sender, EventArgs e) {
            OpenROMdialogue();
        }
        private void saveToolStripMenuItem_Click(object sender, EventArgs e) {
            Bits.saveFile(romfn, rom);
        }
        private void saveAsToolStripMenuItem_Click(object sender, EventArgs e) {
            SaveFileDialog sfd = new SaveFileDialog();
            sfd.Title = "Save ROM File";
            //sfd.Filter = "GBA/NDS/3DS file(*.gba;*.nds;*.3ds)|*.gba;*.nds;*.3ds";
            if (sfd.ShowDialog() == DialogResult.OK) {
                romfn = sfd.FileName;
                Bits.saveFile(romfn, rom);
                Properties.Settings.Default.LastRom = romfn;
                Properties.Settings.Default.Save();
            }
        }
        private void nextMapToolStripMenuItem_Click(object sender, EventArgs e) {
            if (sel == map_num) { return; }
            sel += 1;
            loadEntireMap();
        }

        private void previousMapToolStripMenuItem_Click(object sender, EventArgs e) {
            if (sel == 0) { return; }
            sel -= 1;
            loadEntireMap();
        }
        private void Form1_KeyDown(object sender, KeyEventArgs e) {
            switch (e.KeyCode) {
                case (Keys)0x20:
                    tileDisp ^= 1;
                    tWin(lastPressedKey, 1);
                    break;
                case (Keys)0x21:
                    if (sel == map_num) { return; }
                    sel += 1;
                    loadEntireMap();
                    tWin(lastPressedKey, 0);
                    break;
                case (Keys)0x22:
                    if (sel == 0) { return; }
                    sel -= 1;
                    loadEntireMap();
                    tWin(lastPressedKey, 0);
                    break;
                case (Keys)0x31:
                    tWin(0x31, 1);
                    break;
                case (Keys)0x32:
                    tWin(0x32, 1);
                    break;
                case (Keys)0x33:
                    //loadEntireMap();
                    tWin(0x33, 1);
                    break;
                //default:
                //    Map.mapNum += 10;
                //    break;
            }
        }
        int map_num = 0;
        uint sel = 102;//5;

        static void genPixPosTabel(int bitmapWidth) {
            int p = 0;
            //for (int h = 0; h < 4; h += 1) {
            for (short i = 0; i < 8 * bitmapWidth; i += (short)bitmapWidth) {//No flip table
                for (short j = i; j < i + 8; j++) {
                    pixPosTable[p++] = j;
                }
            }
            for (short i = 0; i < 8 * bitmapWidth; i += (short)bitmapWidth) { //X-flip table
                for (short j = (short)(i + 7); i <= j; j--) {
                    pixPosTable[p++] = j;
                }
            }
            for (short i = (short)(7 * bitmapWidth); 0 <= i; i -= (short)bitmapWidth) { //Y-flip table
                for (short j = i; j < i + 8; j++) {
                    pixPosTable[p++] = j;
                }
            }
            for (short i = (short)(7 * bitmapWidth); 0 <= i; i -= (short)bitmapWidth) { //X/Y-flip table
                for (short j = (short)(i + 7); i <= j; j--) {
                    pixPosTable[p++] = j;
                }
            }
        }
        static short[] pixPosTable = new short[0x100]; //Maybe most useful for 3DS pixel rendering? (@GBA/DS unnested tiles: Doesn't really have a noticable speed increase?)
        static byte[] blendflag = null;//Test.
        static int bldmod = 0x3F4F;//0x3F42;//0x3C42;
        static int eva = 8;//0x3C42;
        static int evb = 0x10;//0x3C42;
        byte[] paldat; byte[] tsetdat; byte[] stiles; byte[] tmap; byte[] visfx;
        int[] pos = new int[6];
        int scnw, scnh;
        void loadEntireMap() {
            //init_globals
            filetable &= 0x1FFFFFF;
            uint maps_pos1 = Bits.getUInt32(rom, filetable + 0x18) & 0x1FFFFFF;
            maps_pos1 = Bits.getUInt32(rom, unchecked((int)(maps_pos1 + 0xC))) & 0x1FFFFFF;
            maps_pos1 = Bits.getUInt32(rom, unchecked((int)((maps_pos1 & 0x1FFFFFC) - 4 - 0x3C * ((version == 11) ? 1 : 0)))) & 0x1FFFFFF;

            //ds_map_add(global.data_desc,global.maps_pos1,"Map Data Reference 1")
            uint maps_pos2 = Bits.getUInt32(rom, filetable + 0xC) & 0x1FFFFFF;
            maps_pos2 = Bits.getUInt32(rom, unchecked((int)(maps_pos2 + 0x10C + 0x20 * ((version == 0) ? 1 : 0)))) & 0x1FFFFFF;
            uint maps_off = Bits.getUInt32(rom, unchecked((int)((maps_pos2 & 0x1FFFFFC) - 4 - 0x160 * ((version == 0) ? 1 : 0)))) & 0x1FFFFFF;
            maps_pos2 = Bits.getUInt32(rom, unchecked((int)((maps_pos2 & 0x1FFFFFC) - 8 - 0x164 * ((version == 0) ? 1 : 0)))) & 0x1FFFFFF;

            //ds_map_add(global.data_desc,global.maps_pos2,"Map Data Reference 2")
            int mapid_str = 0;

            if (version == 0) {
                switch (language) {
                    case 'J': mapid_str = 2624; break;
                    case 'E': mapid_str = 2567; break;
                    default: mapid_str = -1; break;
                }
                map_num = 201;
            } else if (version == 1) {
                switch (language) {
                    case 'J': mapid_str = 3772; break;
                    case 'D':
                    case 'S':
                    case 'F':
                    case 'I': mapid_str = 4231; break;
                    case 'E':
                    case 'C': mapid_str = 3770; break;
                    default: mapid_str = -1; break;
                }
                map_num = 325;
            } else if (version == 10) {
                mapid_str = 0;
                map_num = 55;
            } else if (version == 11) {
                mapid_str = 882;
                map_num = 69;
            }
            //obj_eMaps > User Defined 1 //Swap all to Unsigned?
            //uint sel = 16;
            uint loc = (maps_pos1 + 8 * sel) & 0x1FFFFFF; //file_bin_seek(global.file,(global.maps_pos1+8*sel)&$1FFFFFF)
            int code = Bits.getInt16(rom, loc); //show_message(string_hex(READU8(global.file,READU32(global.file,(global.filetable+(code<<2)))),2)+', '+string_hex(dataresource_size(code),8))
            //rom(loc + 2) //Music/Name?
            //rom(loc + 3) //???
            int map = Bits.getInt16(rom, loc + 4);
            loc = unchecked((uint)((maps_pos2 + 12 * map) & 0x1FFFFFF)); //file_bin_seek(global.file,(global.maps_pos2+12*map)&$1FFFFFF)
            pos[0] = Bits.getInt16(rom, loc);
            pos[1] = Bits.getInt16(rom, loc + 2);
            pos[2] = Bits.getInt16(rom, loc + 4);
            pos[3] = Bits.getInt16(rom, loc + 6);
            pos[4] = Bits.getInt16(rom, loc + 8);
            pos[5] = Bits.getInt16(rom, loc + 10);

            for (int a = 0; a < 6; a++) {
                pos[a] = Bits.getInt32(rom, unchecked((int)(filetable + ((pos[a] + maps_off) << 2)) & 0x1FFFFFF)) & 0x1FFFFFF;
            }
            int world_map = (map == 1) ? 1 : 0;
            /* Skip for now.
 file_bin_seek(global.file,(global.filetable+(code<<2))&$1FFFFFF)
 code=READ_UINT(global.file)
 code_f=decompressMapCode(global.file,code,temp_directory+'\code.bin')
 code=file_bin_open(code_f,2)
             */
            //byte[] t = decompress(rom, 0xA8B1B8, 0); //Format 2
            //byte[] t = decompress(rom, 0x888FE4 + 0x80, 0); //Format 2
            //byte[] t = decompress16(rom, 0x4F157, 0); //Format 2
            //byte[] t = decompText(rom, 0x111); // decompBtlBG(rom, 0x7765D8 + 0x100);
            paldat = new byte[0x1C0]; //0x200];
            decompress(rom, pos[1], paldat, 0); initPal(paldat, 0, 0xE0); //pictureBox1.Image = PixelsToImage(pal, 16, 14, 16);
            tsetdat = new byte[0x10000];
            decompress(rom, pos[2], tsetdat, 0x0000);
            decompress(rom, pos[3], tsetdat, 0x4000);
            decompress(rom, pos[4], tsetdat, 0x8000);
            decompress(rom, pos[5], tsetdat, 0xC000);

            scnw = rom[pos[0] + 0x2] * 8;
            scnh = rom[pos[0] + 0x3] * 8;

            stiles = new byte[0x10000]; tmap = new byte[0x10000]; visfx = new byte[0x200];
            //int length =
            decompTileData(rom, pos[0] + (Bits.getInt32(rom, pos[0] + 0x24)), stiles, 0); //8x8 tile table - Decompress & Deobfuscate.
            //Height Tile Data - Skip for now.
            decompMap2(rom, pos[0] + (Bits.getInt32(rom, pos[0] + 0x2C)), tmap, 0); //16x16 tilemap - Decompress & Deobfuscate.
            //Height Tilemap - Skip for now.
            //Animation
            if (Bits.getInt32(rom, pos[0] + 0x38) != 0) { decompress(rom, pos[0] + (Bits.getInt32(rom, pos[0] + 0x38)), visfx, 0); } //catch { } //Visual Effects
            //Coord data
            

            //shift[0]=READ_UBYTE(global.file)+(READ_UBYTE(global.file)<<7)
            this.Text = sel.ToString() + " - " + pos[0].ToString("X8");
            //Temporary error avoidance:
            dMap = 0;
            if (scnw == 0) { this.Text += (" (Error - Width was 0)").ToString(); scnw = 0x80 * 16; scnh = 0x36*16; } //Anti-error for... was it sel 102(?)
            if (scnh == 0) { this.Text += (" (Error - Height was 0)").ToString(); scnh = 16; }
            if ((sel == 175) || (sel == 176) || (sel == 202) || (sel == 229)) { this.Text += (" (Error for 175, 176, 202, and 229)").ToString(); return; }
            dMap = 1;
            dispMap();
        }
        int dMap = 1;
        void dispMap() {
            if (dMap == 0) { return; }
            int[] bmpdata = new int[scnw * scnh];
            //for (int l = 0; l < 3; l += 1) {
            //    int shift = rom[pos[0] + 0xC + (l * 8)] + (rom[pos[0] + 0xD + (l * 8)] << 7);
            //    for (int dy = 0; dy < rom[pos[0] + 0x3]; dy += 2) {
            //        for (int dx = 0; dx < rom[pos[0] + 0x2]; dx += 2) {
            //            int t = Bits.getInt16(tmap, 0x8000 + dx + shift + (dy << 7)) & 0xFFF;
            //            for (int t8 = 0; t8 < 8; t8 += 2) {
            //                int tile = Bits.getInt16(stiles, t * 8);
            //                int t2 = ((tile & 0x3FF) + ((rom[pos[0] + 7 + l] - 1) * 0x200)) << 5; //+ tset
            //                int tilePal = (tile >> 8) & 0xF0;
            //                for (int n = 0; n < 0x40; n += 2) {
            //                    int ry = y; if ((tile & 0x800) != 0) { ry = r + ((7 - y) & 7); } //Vert. flip
            //                    int rx = x; if ((tile & 0x400) != 0) { rx = c + ((7 - x) & 7); } //Horr. flip
            //                    int pix = tsetdat[t2++];
            //                    int pix2 = pix & 0xF;
            //                    if (pix2 != 0) {
            //                        bmpdata[((dy*8 + (t8&4)*2 + (n>>3)) * width) + rx] = pal[tilePal | (pix2)];
            //                    }
            //                    int rx = x + 1; if ((tile & 0x400) != 0) { rx = c + ((7 - x) & 7); } //Horr. flip
            //                    pix2 = pix >> 4;
            //                    if (pix2 != 0) {
            //                        bmpdata[(ry * width) + rx] = pal[tilePal | (pix2)];
            //                    }
            //                }
            //            }
            //        }
            //    }
            //}
            //int mappos = 0;
            //return;
            //try {
            genPixPosTabel(scnw);
            //PREPARE BLENDING INFO!
            blendflag = new byte[(scnw * scnh) >> 3];// bldmod = 0;
            bldmod = Bits.getInt16(visfx, 0);// | 0xF;
            eva = visfx[2];
            evb = visfx[3];
            //int bldaddr = 0x3B78AC + (rom[0x3A78D4 + (mapNum * 0x18) + 0x9] << 3);
            //bldmod = Bits.getInt32(rom, bldaddr);
            //bldmod = ((bldmod & 0xFC0) << 2) | (bldmod & 0x3F);
            //int evaddr = Bits.getInt32(rom, bldaddr + 4);
            //if (evaddr != 0) {
            //    bldmod |= 0x40;
            //    int evdata = Bits.getInt32(rom, evaddr & 0x1FFFFFF);
            //    eva = evdata & 0x1F;
            //    evb = (evdata >> 5) & 0x1F;
            //}
            int m = 0; int l = 3;
                while (m < 4) { //for (int m = 1; m <= 3; m++) {
                    l--; //int l = 2;
                    while ((l >= 0) && (rom[pos[0] + 4 + l] != m)) {
                        l--;
                    }
                    if (l < 0) { l = 3; m++; continue; }
                    int layiOffset = 1 << (3 - l);
                    int shiftx = rom[pos[0] + 0xC + (l * 8)], shifty = rom[pos[0] + 0xD + (l * 8)];
                    int shift = (shiftx & 0xfe) + ((shifty & 0xfe) << 7);
                    for (int row = 0; row < (scnh); row += 16) {
                        for (int col = 0; col < (scnw); col += 16) {
                            //int t = Bits.getInt16(tmap, 0x8000 + dx + shift + (dy << 7)) & 0xFFF;
                            int t = (Bits.getInt16(tmap, 0x8000 + (col >> 3) + shift + (row << 4)) & 0xFFF) * 8;
                            //try {
                                for (int r = row; r < row + 16; r += 8) {
                                    for (int c = col; c < col + 16; c += 8) {
                                        int tile = Bits.getInt16(stiles, t); t += 2;

                                        int q = (tile >> 4) & 0xC0;
                                        int tilepos = ((r * scnw) + c);
                                        //int k = q + 0x40;
                                        //int t2 = ((tile & 0x3FF) + ((rom[pos[0] + 7 + l] - 1) * 0x200)) << 5; //+ tset
                                        int t2 = ((tile & 0x3FF) << 5) + ((rom[pos[0] + 7 + l] - 1) * 0x4000); //+ tset
                                        if (t2 >= 0) {
                                            int tilePal = (tile >> 8) & 0xF0;
                                            for (int y = r; y <= r + 7; y++) {
                                                int ry = y; if ((tile & 0x800) != 0) { ry = r + ((7 - y) & 7); } //Vert. flip
                                                ry -= (shifty & 1) * 8; if (ry < 0) { continue; }
                                                //int pix = ram.getInt32(pos); pos += 4;
                                                for (int x = c; x <= c + 7; x += 2) {
                                                    int rx = x; if ((tile & 0x400) != 0) { rx = c + ((7 - x) & 7); } //Horr. flip
                                                    rx -= (shiftx & 1) * 8; if (rx < 0) { continue; }
                                                    int pix = tsetdat[t2++];
                                                    int pix2 = pix & 0xF;
                                                    if (pix2 != 0) {
                                                        //bmpdata[(ry * scnw) + rx] = pal[tilePal | (pix2)];
                                                        //priomap[(ry * bitmapWidth) + rx] = priority;
                                                        int mappos = tilepos + pixPosTable[q];
                                                        if (((blendflag[mappos >> 3] >> (mappos & 7)) & 1) == 1) {
                                                            if ((bldmod & (0xC0 | (layiOffset << 8))) == (0x40 | (layiOffset << 8))) {
                                                                bmpdata[mappos] = blendit(bmpdata[mappos], pal[tilePal | pix2], eva, evb);
                                                            }
                                                            blendflag[mappos >> 3] ^= (byte)(1 << (mappos & 7));
                                                        } else if (bmpdata[mappos] == 0) {
                                                            bmpdata[mappos] = pal[tilePal | pix2];
                                                            //priomap[(ry * bitmapWidth) + rx] = priority;
                                                            if ((bldmod & (0xC0 | layiOffset)) == (0x40 | layiOffset)) {
                                                                blendflag[mappos >> 3] |= (byte)(1 << (mappos & 7));
                                                            }
                                                        }
                                                    } q++;
                                                    //pix >>= 4;
                                                    rx = x + 1; if ((tile & 0x400) != 0) { rx = c + ((7 - (x + 1)) & 7); } //Horr. flip
                                                    pix2 = pix >> 4;
                                                    if (pix2 != 0) {
                                                        //bmpdata[(ry * scnw) + rx] = pal[tilePal | (pix2)];
                                                        //priomap[(ry * bitmapWidth) + rx] = priority;
                                                        int mappos = tilepos + pixPosTable[q];
                                                        if (((blendflag[mappos >> 3] >> (mappos & 7)) & 1) == 1) {
                                                            if ((bldmod & (0xC0 | (layiOffset << 8))) == (0x40 | (layiOffset << 8))) {
                                                                bmpdata[mappos] = blendit(bmpdata[mappos], pal[tilePal | pix2], eva, evb);
                                                            }
                                                            blendflag[mappos >> 3] ^= (byte)(1 << (mappos & 7));
                                                        } else if (bmpdata[mappos] == 0) {
                                                            bmpdata[mappos] = pal[tilePal | pix2];
                                                            //priomap[(ry * bitmapWidth) + rx] = priority;
                                                            if ((bldmod & (0xC0 | layiOffset)) == (0x40 | layiOffset)) {
                                                                blendflag[mappos >> 3] |= (byte)(1 << (mappos & 7));
                                                            }
                                                        }
                                                    } q++;
                                                    //pix >>= 4;
                                                }
                                            }
                                        }
                                    }
                                }
                            //} catch { }
                        }
                    }

                }
            //} catch { }
            pictureBox1.Width = scnw; pictureBox1.Height = scnh;
            pictureBox1.Image = PixelsToImage(bmpdata, scnw, scnh);
           //System.IO.File.WriteAllBytes("C:/Users/Tea/Desktop/gsdtest.dmp", tsetdat); //stiles);
        }
        //void tile_add(int[] mapBmp, int mapPos, byte[] tsetBmp, int tsetPos, int[] pal, int tileInfo) {

        //}
        public static int blendit(int first, int second, int eva, int evb) {
            int blue = (((byte)first * eva) >> 4) + (((byte)second * evb) >> 4);
            if (blue > 0xF8) { blue = 0xF8; }
            int green = (((byte)(first >> 8) * eva) >> 4) + (((byte)(second >> 8) * evb) >> 4);
            if (green > 0xF8) { green = 0xF8; }
            int red = (((byte)(first >> 16) * eva) >> 4) + (((byte)(second >> 16) * evb) >> 4);
            if (red > 0xF8) { red = 0xF8; }
            return unchecked((int)0xFF000000) | ((red << 16) | (green << 8) | blue) & 0xF8F8F8;
        }
        public int[] pal = new int[0x100];
        public void initPal(byte[] src, int srcPos, int num) { // int[] des, int desPos, int num) { //Loads palette data into 32-bit array with reversed format.
            //rom.seek(0x8C88C8);
            for (int i = 0; i < num; i++) {
                int palt = Bits.getInt16(src, srcPos + (i * 2));
                //pal[i] = (short)(((palt & 0x1F) << 10) | (palt & 0x3E0) | (palt >> 10));
                pal[i] = unchecked((int)0xFF000000) | ((palt & 0x1F) << 0x13) | ((palt & 0x3E0) << 6) | ((palt >> 7) & 0xF8);
            }
        }
        //Only needed to display zoomed in Palette bitmap,
        public static Bitmap PixelsToImage(int[] array, int width, int height, int zoom) {
            if (zoom <= 0) { return new Bitmap(1, 1); }
            int[] array2 = new int[width * height * zoom * zoom];
            //for (int i = 0; i < (width * height); i++) {
            int i = 0;
            for (int yt = 0; yt < (height * zoom) * (width * zoom); yt += (width * zoom) * zoom) {
                for (int xt = yt; xt < yt + (width * zoom); xt += zoom) {
                    int palt = array[i++];
                    for (int y = xt; y < xt + (width * zoom) * zoom; y += (width * zoom)) {
                        for (int x = y; x < y + zoom; x++) {
                            array2[x] = palt;
                        }
                    }
                }
            }
            return PixelsToImage(array2, width * zoom, height * zoom);
        }
        public static Bitmap PixelsToImage(int[] array, int width, int height) {
            Bitmap bitmap = new Bitmap(width, height, PixelFormat.Format32bppRgb);
            Rectangle rect = new Rectangle(0, 0, bitmap.Width, bitmap.Height);
            BitmapData bitmapData = bitmap.LockBits(rect, ImageLockMode.ReadWrite, bitmap.PixelFormat);
            IntPtr pNative = bitmapData.Scan0;
            Marshal.Copy(array, 0, pNative, width * height);
            bitmap.UnlockBits(bitmapData);
            return bitmap;
        }

        void decompTileData(byte[] src, int srcPos, byte[] des, int desPos) {
            byte[] t = new byte[0x10000];
            int length = decompress(src, srcPos, t, desPos);
            //byte[] stiles = new byte[0x8000];
            int i = 0, pos1, pos2, n = 0;
            switch (t[0]) {
                case 1:
                    pos2 = (length >> 1) + 1;
                    for (pos1 = 1; pos1 < (length >> 1); i += 2) {
                        n ^= ((t[pos1++] << 8) | (t[pos2++]));
                        des[i] = (byte)n; des[i + 1] = (byte)(n >> 8);
                    }
                    break;
                case 2:
                    for (i = 1; i < (length - 1); i += 2) {
                        n ^= t[i] | (t[i + 1] << 8);
                        des[i - 1] = (byte)n; des[i] = (byte)(n >> 8);
                    }
                    break;
                default: //case 0:
                    for (i = 0; i < length; i++) {
                        des[i] = t[i + 1];
                    }
                    break;
            }
            length--;
            t8amt = length >> 3;
        }
        void decompMap2(byte[] src, int srcPos, byte[] des, int desPos) {
            decompress(src, srcPos, des, desPos);
            uint b = 0xFFFFF001, pos1, num;
            for (pos1 = 0x8000; pos1 < 0x10000; pos1 += 2) {
                num = (uint)(des[pos1] | (des[pos1 + 1] << 8));
                if ((num << 20) == 0xFFF00000) {
                    num += b;
                    if (b != 0) { b++; }
                }
                des[pos1] = (byte)num; des[pos1 + 1] = (byte)(num >> 8);
            }
        }

        private void editorsToolStripMenuItem_Click(object sender, EventArgs e) {
            Editors eds = new Editors();
            eds.test = this;
            eds.Show();
        }
        //byte[] paldat; byte[] tsetdat; byte[] stiles;
        public Bitmap dispTsetImg(int charBase) {
            int tspos = 0;
            int[] bmpdata = new int[0x80000];
            //for (int row = 0; row < 0x200; row += 16) {
                //for (int col = 0; col < 0x100; col += 16) {
            for (int r = 0; r < 0x280; r += 8) {
                for (int c = 0; c < 0x100; c += 8) {
                    //int tile = rom.getInt16(tsetaddr[0] + tspos); tspos += 2;
                    int tile = tspos;//Bits.getInt16(stiles, tspos);
                    tspos += 1;
                    //if (tsetaddr[tspos >> 12] == -1) { tile = 0; } else { tile = Bits.getInt16(rom, tsetaddr[tspos >> 12] + (tspos & 0xFFF)); tspos += 2; } //tspos &= 0xFFF;
                    int pos = tile << 5; // (tile & 0x3FF) << 5;
                    //pos += charBase;
                    int tilePal = 0;// (tile >> 8) & 0xF0;
                    pos -= 0x4000; if (pos < 0) { continue; }
                    //int x1, x2, xi, y1, y2, yi; // Not sure how I wanted flipping coded in?  Alternative below, though!
                    //if ((tile & 0x400) == 0) { x1 = 0; x2 = 7; xi = 1; } else { x1 = 7; x2 = 0; xi = -1; };
                    //if ((tile & 0x800) == 0) { y1 = 0; y2 = 7; yi = 1; } else { y1 = 7; y2 = 0; yi = -1; };
                    for (int y = r; y <= r + 7; y++) {
                        int ry = y; //if ((tile & 0x800) != 0) { ry = r + ((7 - y) & 7); } //Vert. flip
                        int pix = Bits.getInt32(tsetdat, pos); pos += 4;
                        for (int x = c; x <= c + 7; x++) {
                            int rx = x; //if ((tile & 0x400) != 0) { rx = c + ((7 - x) & 7); } //Horr. flip
                            bmpdata[(ry << 9) + rx] = pal[tilePal | (pix & 0xF)];
                            pix >>= 4;
                        }
                    }
                }
            }
                //}
            //}
            //charBase indicator
            for (int y = 0; y < charBase; y++) {
                bmpdata[(y << 9) + 0x100] = 0xF80000;
                bmpdata[(y << 9) + 0x101] = 0xF80000;
            }
            for (int y = charBase; y < charBase + 0x100; y++) {
                bmpdata[(y << 9) + 0x100] = 0x00F800;
                bmpdata[(y << 9) + 0x101] = 0x00F800;
            }
            for (int y = charBase + 0x100; y < 0x200; y++) {
                bmpdata[(y << 9) + 0x100] = 0xF80000;
                bmpdata[(y << 9) + 0x101] = 0xF80000;
            }
            return PixelsToImage(bmpdata, 0x200, 0x400);
        }
        public Bitmap dispTileset(int charBase) {//(ByVal tsslot As Integer) {
            //tsetaddr[0]
            int tspos = 0;
            //int[] bmpdata = new int[0x20000];
            int[] bmpdata = new int[0x80000];
            //for (int row = 0; row < 16; row++) {
            //    for (int col = 0; col < 32; col++) {
            for (int row = 0; row < 0x400; row += 16) {
                for (int col = 0; col < 0x200; col += 16) {
                    for (int r = row; r < row + 16; r += 8) {
                        for (int c = col; c < col + 16; c += 8) {
                            //int tile = rom.getInt16(tsetaddr[0] + tspos); tspos += 2;
                            int tile =  Bits.getInt16(stiles, tspos); tspos += 2;
                            //if (tsetaddr[tspos >> 12] == -1) { tile = 0; } else { tile = Bits.getInt16(rom, tsetaddr[tspos >> 12] + (tspos & 0xFFF)); tspos += 2; } //tspos &= 0xFFF;
                            int pos = (tile & 0x3FF) << 5;
                            pos += charBase;
                            int tilePal = (tile >> 8) & 0xF0;
                            pos -= 0x4000; if (pos < 0) { continue; }
                            //int x1, x2, xi, y1, y2, yi; // Not sure how I wanted flipping coded in?  Alternative below, though!
                            //if ((tile & 0x400) == 0) { x1 = 0; x2 = 7; xi = 1; } else { x1 = 7; x2 = 0; xi = -1; };
                            //if ((tile & 0x800) == 0) { y1 = 0; y2 = 7; yi = 1; } else { y1 = 7; y2 = 0; yi = -1; };
                            for (int y = r; y <= r + 7; y++) {
                                int ry = y; if ((tile & 0x800) != 0) { ry = r + ((7 - y) & 7); } //Vert. flip
                                int pix = Bits.getInt32(tsetdat, pos); pos += 4;
                                for (int x = c; x <= c + 7; x++) {
                                    int rx = x; if ((tile & 0x400) != 0) { rx = c + ((7 - x) & 7); } //Horr. flip
                                    bmpdata[(ry << 9) + rx] = pal[tilePal | (pix & 0xF)];
                                    pix >>= 4;
                                }
                            }
                        }
                    }
                }
            }
            return PixelsToImage(bmpdata, 0x200, 0x400);// 0x100);
        }
        //private void tWin() {
        //    Form ts = new Form();
        //    //ts.FormBorderStyle = FormBorderStyle.FixedToolWindow;
        //    ts.FormBorderStyle = FormBorderStyle.SizableToolWindow;
        //    ts.ClientSize = new Size(512, 769); //ts.Width = 512; ts.Height = 512;
        //    //ts.StartPosition = FormStartPosition.Manual;// Screen.PrimaryScreen.Bounds.Width - 512; 
        //    //ts.SetDesktopLocation(Screen.PrimaryScreen.Bounds.Width - 525, 25);
        //    //ts.BackgroundImageLayout = ImageLayout.None;
        //    ts.AutoScroll = true; //Adds scrollbars to form.
        //    //ts.StartPosition
        //    ts.Show(this);
        //    PictureBox tspicBox1 = new PictureBox(); //System.Windows.Forms.
        //    tspicBox1.Size = new System.Drawing.Size(0x200, 0x400);
        //    ts.Controls.Add(tspicBox1);
        //    ((PictureBox)ts.Controls[0]).Image = dispTileset();
        //}
        int tileDisp = 0;
        Form ts = new Form(); int lastPressedKey = 0;
        void tWin(int controlSet, int showForm) { //showForm is temp arg??? //updateToolBox
            //if (ts.Visible == true) { tspicBox1.Image = Map.dispTileset(); }
            if (lastPressedKey != controlSet) {
                ts.Controls.Clear();
                lastPressedKey = controlSet;
            }
            if (ts.IsDisposed || !ts.Visible) {
                if (showForm == 0) { return; }
                ts = new Form();
                //ts.FormBorderStyle = FormBorderStyle.FixedToolWindow;
                ts.FormBorderStyle = FormBorderStyle.SizableToolWindow;
                ts.ClientSize = new Size(529, 769); //ts.Width = 512; ts.Height = 512; //512,769
                //ts.StartPosition = FormStartPosition.Manual;// Screen.PrimaryScreen.Bounds.Width - 512; 
                //ts.SetDesktopLocation(Screen.PrimaryScreen.Bounds.Width - 525, 25);
                //ts.BackgroundImageLayout = ImageLayout.None;
                ts.AutoScroll = true; //Adds scrollbars to form.
                //ts.StartPosition
                ts.Show(this); //Setting the owner to "this" form makes windows stay in front of main form, but not in front of other apps like .TopMost.
                ts.KeyDown += new KeyEventHandler(this.Form1_KeyDown);
                //ts.MouseDown += new MouseEventHandler(this.tsDefocus);

            }
            switch (controlSet) {
                case 0x31:
                case 0x32:
                case 0x33:
                    if (ts.Controls.Count == 0) { //Init
                        PictureBox tspicBox1 = new PictureBox(); //System.Windows.Forms.
                        tspicBox1.Size = new System.Drawing.Size(0x200, 0x400);
                        ts.Controls.Add(tspicBox1);
                        //tsClick += new System.EventHandler(this.tsClick);
                        tspicBox1.MouseDown += new MouseEventHandler(this.tsClick);
                        tspicBox1.MouseMove += new MouseEventHandler(this.tsClick);//Move);
                        tspicBox1.Paint += new PaintEventHandler(this.tsPaint);
                    }
                    if (tileDisp == 0) {
                        ((PictureBox)ts.Controls[0]).Image = dispTsetImg(rom[pos[0] + 7 + (controlSet - 0x31)] * 0x80);
                    } else {
                        ((PictureBox)ts.Controls[0]).Image = dispTileset(rom[pos[0] + 7 + (controlSet - 0x31)] * 0x4000); //tspicBox1.Image = Map.dispTileset();
                    }
                    break;
                case 0x34: //Solidity
                    break;
                case 0x37: //Area Scripts
                    if (ts.Controls.Count == 0) {
                    }
                    //loadAreaData();
                    break;
                case 0x38: //Warps
                    if (ts.Controls.Count == 0) {
                    }
                    
                    //if (((NumericUpDown)ts.Controls[1]).Value != 0) { //Commented because changing visibility of warp boxes will set to 0.
                    //    ((NumericUpDown)ts.Controls[1]).Value = 0;
                    //} else {
                    // loadWarpData(); //Not sure of best way to trigger ValueChanged. :(
                    //}
                    break;
            }
        }
        int t8ind = 0;
        int t16ind = 0;
        void tsClick(object sender, MouseEventArgs e) {
            if (MouseButtons != MouseButtons.Left) { return; }
            if (tileDisp == 0) {
                int a = rom[pos[0] + 7 + (lastPressedKey - 0x31)] * 0x80;
                if ((e.Y < a) || ((a + 0x100) <= e.Y)) { return; }
                if ((e.X < 0) || (0x100 <= e.X)) { return; }
                t8ind = (((e.Y - a) >> 3) << 5) | (e.X >> 3);
            } else {
                t16ind = ((e.Y >> 4) << 5) | (e.X >> 4);
            }
            ((PictureBox)ts.Controls[0]).Invalidate();
            //tWin(lastPressedKey, 0);
        }
        void tsPaint(object sender, PaintEventArgs e) {
            if (tileDisp == 0) {
                int a = rom[pos[0] + 7 + (lastPressedKey - 0x31)] * 0x80;
                e.Graphics.DrawRectangle(new Pen(Brushes.Red), (t8ind & 0x1F) << 3, a + (((t8ind >> 5) & 0x1F) << 3), 7, 7);
            } else {
                e.Graphics.DrawRectangle(new Pen(Brushes.Red), (t16ind & 0x1F) << 4, ((t16ind >> 5) & 0x1F) << 4, 15, 15);
            }
        }
        int xp = 0, yp = 0;
        void mapClick(object sender, MouseEventArgs e) {
            if (MouseButtons != MouseButtons.Left) { return; }
            //int layiOffset = 1 << (3 - l);
            //        int shiftx = rom[pos[0] + 0xC + (l * 8)], shifty = rom[pos[0] + 0xD + (l * 8)];
            //        int shift = (shiftx & 0xfe) + ((shifty & 0xfe) << 7);
            //        for (int row = 0; row < (scnh); row += 16) {
            //            for (int col = 0; col < (scnw); col += 16) {
            //                //int t = Bits.getInt16(tmap, 0x8000 + dx + shift + (dy << 7)) & 0xFFF;
            //                int t = (Bits.getInt16(tmap, 0x8000 + (col >> 3) + shift + (row << 4)) & 0xFFF) * 8;
            
            int l = lastPressedKey - 0x31;
            if ((l < 0) || (l > 2)) { return; }
            int shiftx = rom[pos[0] + 0xC + (l * 8)], shifty = rom[pos[0] + 0xD + (l * 8)];
            int shift = (shiftx & 0xfe) + ((shifty & 0xfe) << 7);
            int t = Bits.getInt16(tmap, 0x8000 + ((e.X >> 4) << 1) + shift + ((e.Y >> 4) << 8));// & 0xF000) | t16ind;
            //MessageBox.Show(e.X.ToString());
            if (tileDisp == 0) { //Check if replacing tile is in use, then insert tile if enough space.
                //if (((xp >> 3) == (e.X >> 3)) && ((yp >> 3) == (e.Y >> 3))) { return; }
                //xp = e.X; yp = e.Y;
                
                // Bits.setInt16(tmap, 0x8000 + ((e.X >> 4) << 1) + shift + ((e.Y >> 4) << 8), t);
                //for (int i = 0; i < 0x8000; i+= 2) Bits.setInt16(tmap, i + 0x8000, i);
                byte[] data = new byte[8];
                for (int i = 0; i < 8; i++) {
                    data[i] = stiles[((t & 0xFFF) * 8) + i];
                }
                //TODO: CHANGE DATA
                int t8a = 0; while (t8a < (t8amt * 8)) {
                    int i = 0; while (i < 8) {
                        if (stiles[t8a + i] != data[i]) { break; }
                        i++;
                    }
                    if (i == 8) { break; }
                //    //if (i < 8) { continue; } break;
                    t8a += 8;
                }
                if ((t8a >> 3) < 0x800) {
                    if (t8a == (t8amt * 8)) {
                        for (int i = 0; i < 8; i++) {
                            stiles[(t8amt * 8) + i] = data[i];
                        }
                    }
                    Bits.setInt16(tmap, 0x8000 + ((e.X >> 4) << 1) + shift + ((e.Y >> 4) << 8), (t & 0xF000) | t16ind);
                    //ind[t] = t8amt++; //If code is un-commented, make ind[t] = t8a>>3. (Outside if loop.) 
                }
                dispMap();
            } else { //Just set tile.
                //if (((xp >> 4) == (e.X >> 4)) && ((yp >> 4) == (e.Y >> 4))) { return; }
                //xp = e.X; yp = e.Y;
                if ((t & 0xFFF) == t16ind) { return; }
                Bits.setInt16(tmap, 0x8000 + ((e.X >> 4) << 1) + shift + ((e.Y >> 4) << 8), (t & 0xF000) | t16ind);
                //for (int i = 0; i < 0x8000; i+= 2) Bits.setInt16(tmap, i + 0x8000, i);
                dispMap();
            }
            sortTiles(); //Re-organize tiles.
        }
        int t8amt = 0;
        void sortTiles() {
            int[] freq = new int[0x1000];
            int[] ind = new int[0x1000];
            byte[] stiles2 = new byte[0x10000];
            t8amt = 0;
            for (int ti = 0x8000; ti < 0x10000; ti += 2) {
                int ta = Bits.getInt16(tmap, ti);
                int t = ta & 0xFFF;
                if (freq[t] == 0) {
                    //int t8a = 0; while (t8a < (t8amt * 8)) {
                    //    int i = 0; while (i < 8) {
                    //        if (stiles2[t8a + i] != stiles[t * 8 + i]) { break; }
                    //        i++;
                    //    }
                    //    if (i == 8) { break; }
                    //    //if (i < 8) { continue; } break;
                    //    t8a += 8;
                    //}
                    //if (t8a == (t8amt * 8)) {
                        for (int i = 0; i < 8; i++) {
                            stiles2[(t8amt * 8) + i] = stiles[t * 8 + i];
                        }
                        ind[t] = t8amt++; //If code is un-commented, make ind[t] = t8a>>3. (Outside if loop.) 
                    //}
                    //t = t8a >> 3;
                    //Bits.setInt16(tmap, ti, (ta & 0xF000) | (t8a >> 3));
                    //Bits.setInt16(tmap, ti, (ta & 0xF000) | t8amt);
                }
                Bits.setInt16(tmap, ti, (ta & 0xF000) | ind[t]);
                freq[t]++;
            }
            stiles = stiles2;
        }
    }
}